﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using System.Collections;

namespace BaseApplicationProject
{
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.PreviousWindowSize = this.Width;
        }

        private const int ALLOWED_OFFSET = 200;
        private const int RIBBON_GALLERY_ITEM_WIDTH = 56;
        private double PreviousWindowSize { get; set; }

        private void RadRibbonGallery_Loaded(object sender, RoutedEventArgs e)
        {
            this.RibbonGallery.MaxWidth = this.RibbonGallery.Items.Count * RIBBON_GALLERY_ITEM_WIDTH;
        }

        private void Window_SizeChanged(object sender, SizeChangedEventArgs e)
        {
            var remainingWidth = GetRemainingSpace(this.HomeTab.Items, this.radRibbonView);
            
            if (double.IsNaN(this.RibbonGallery.Width) ||
                this.RibbonGalleryGroup.Variant == RibbonGroupVariant.Collapsed && remainingWidth > ALLOWED_OFFSET)
            {
                this.RibbonGallery.Width = 0;
                this.RibbonGallery.ViewportWidth = 0;
                this.RibbonGallery.PopupViewportWidth = 0;
            }

            var windowOffset = this.Width - this.PreviousWindowSize;

            var galleryNewWidth = this.RibbonGallery.Width + windowOffset;
            var viewportNewWidth = this.RibbonGallery.ViewportWidth + windowOffset;
            this.PreviousWindowSize = this.Width;

            this.RibbonGallery.Width = Math.Max(this.RibbonGallery.MinWidth, galleryNewWidth);
            this.RibbonGallery.ViewportWidth = Math.Max(this.RibbonGallery.MinWidth, viewportNewWidth);
            this.RibbonGallery.PopupViewportWidth = Math.Min(this.RibbonGallery.MaxWidth, viewportNewWidth);
        }

        private double GetRemainingSpace(ItemCollection elements, FrameworkElement container)
        {
            double elementsWidthSum = 0;
            foreach (RadRibbonGroup item in elements)
            {
                elementsWidthSum += item.ActualWidth;
            }

            var remainingWidth = container.ActualWidth - elementsWidthSum;
            return remainingWidth;
        }
    }
}
